// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef LFSR_APB_WRAPPER_HH
#define LFSR_APB_WRAPPER_HH

#include <cstddef>
#include <stdint.h>

class lfsr_apb_wrapper
{

public:

    uint32_t pwdata_old;
    bool pwrite_old;
    bool penable_old;
    bool psel_old;
    uint32_t paddr_old;
    bool presetn_old;
    bool pclk_old;
    struct lfsr_apb_wrapper_iostruct{
        bool * pclk;
        bool * presetn;
        uint32_t * paddr;
        bool * psel;
        bool * penable;
        bool * pwrite;
        uint32_t * pwdata;
        bool * pready;
        uint32_t * prdata;

        lfsr_apb_wrapper_iostruct():
            pclk(nullptr),
            presetn(nullptr),
            paddr(nullptr),
            psel(nullptr),
            penable(nullptr),
            pwrite(nullptr),
            pwdata(nullptr),
            pready(nullptr),
            prdata(nullptr)
        {}

        lfsr_apb_wrapper_iostruct( bool * pclk_2, bool * presetn_2, uint32_t * paddr_2,
             bool * psel_2, bool * penable_2, bool * pwrite_2, uint32_t * pwdata_2,
             bool * pready_2, uint32_t * prdata_2 ):
            pclk(pclk_2),
            presetn(presetn_2),
            paddr(paddr_2),
            psel(psel_2),
            penable(penable_2),
            pwrite(pwrite_2),
            pwdata(pwdata_2),
            pready(pready_2),
            prdata(prdata_2)
        {}

        ~lfsr_apb_wrapper_iostruct()
        {}

        bool operator == (const lfsr_apb_wrapper_iostruct & other) const
        {
            if (pclk != other.pclk) return false;
            if (presetn != other.presetn) return false;
            if (paddr != other.paddr) return false;
            if (psel != other.psel) return false;
            if (penable != other.penable) return false;
            if (pwrite != other.pwrite) return false;
            if (pwdata != other.pwdata) return false;
            if (pready != other.pready) return false;
            if (prdata != other.prdata) return false;
            return true;
        }
    };
    lfsr_apb_wrapper_iostruct hif_a2t_data;
    uint32_t prdata_var_0;
    uint8_t prdata_partial0;
    uint8_t out_partial_sig;
    uint8_t old_out_partial_sig;
    uint8_t out_partial_sig_sig_var;
    bool lfsr_0_linear_feedback;

    void hif_cone_lfsr_0_linear_feedback();


    void hif_cone_prdata_partial0();


    void hif_cone_out_partial_sig();

    lfsr_apb_wrapper();


    ~lfsr_apb_wrapper();


    uint8_t out_partial_sig_new;
    bool process_in_queue;
    bool flag_lfsr_0_process_executed;
    bool flag_pos_pclk;
    bool flag_out_partial_sig;

    void lfsr_0_process();


    void globact_process();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    lfsr_apb_wrapper( const lfsr_apb_wrapper & );
    const lfsr_apb_wrapper& operator= ( const lfsr_apb_wrapper & );


};


#endif

